//     
// (c) Proteus
/*
-   .

[1]

          
    ,    
    ,      .
    
  2 .      
 3,4,...  .. .       
        .
     ,   
     (    ).

.          ,
    .      
      .      
  .

,        .
       ,    ,
 ,        .

          4 .
      . 
      ,   .

 :
1)     HTML   3170333, 2441605 
    30 ,   3 .

2)      ( ., ,  ). 1=1024*1024

     '0'-'9' 'a'-'z' '!'-'~'
7    25.2    25.2    104.0
3     9.9     8.2      9.5
2     6.3     5.3      6.1
1     2.9     2.4      2.7
100   1.6     1.4      1.2


[2]
    ,  .
1-       .
2-      ,      .
3-       ,    ,     .
        4 .
4-           , 
      4,8,16,32,...  ..        .
       .
5-      256 ,   .
           128  
   (     ).    64,32,16...   ,
         1 .
6- ...

     . 
     (     ,   ).
   ,      .
       16 .     ,
      16 .       .
*/


#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#define SIZE 70

typedef unsigned char BYTE;

BYTE str1[SIZE+1]; int len1;
BYTE str2[SIZE+1]; int len2;

int step;		//   (    )
int size,count;	//     


//   
struct node_st {
	char sym;		// 
	int count1;		//    str1
	int count2;		//    str2
	int index;		//    
	node_st *tree1;
	node_st *tree2;
};

//  
struct item_st{
	int count1; int list1;
	int count2; int list2;
	node_st *tree;	//     
};

struct data_st{item_st *array; int *list; int count;}data;

//     
#define BANK_SIZE 1024
class Nodes
{
	int count;
	struct bank_st{node_st array[BANK_SIZE]; bank_st *next;}*list;
public:
	Nodes();
	~Nodes();
	node_st *New();
	void Clear();
}nodes;


Nodes::Nodes()
{
	list=0;
	count=0;
}

Nodes::~Nodes()
{
	Clear();
}

node_st *Nodes::New()
{
	if(!count) { 
		bank_st *temp=new bank_st;
		memset(temp,0,sizeof(bank_st));
		temp->next=list; list=temp;
		count=BANK_SIZE;
	}	
	count--; return &list->array[count];
}

void Nodes::Clear()
{
	bank_st *temp;
	while(list) {temp=list; list=list->next; delete temp;}
	count=0;
}

//       
int TreeCalc(node_st *node)
{
	int c,c1,c2;
	if(!node) return 0;
	c1=node->count1;
	c2=node->count2;
	c=c1+c2;
	if(c1 && c2) {
		node->index=count++;
		node->count1=size; size+=c1+1;
		node->count2=size; size+=c2+1;
	} else node->index=-1,c=0;
	c+=TreeCalc(node->tree1)+TreeCalc(node->tree2);
	return c;
}


//     
bool Step()
{
	data_st _data;
	node_st **old,*curr;
	int n,m,i,l;  char sym;
	nodes.Clear();
//  
	for(n=0; n<data.count; n++) {
		for(i=data.array[n].list1; data.list[i]>=0; i++) {
			if(data.list[i]+step>=len1) break;
			sym=str1[data.list[i]+step];
			old=&data.array[n].tree;
			for(;;) {
				curr=*old;
				if(!curr) {
					*old=curr=nodes.New();
					curr->sym=sym;
				}
				if(curr->sym==sym) {curr->count1++;break;}
				if(curr->sym<sym) old=&curr->tree1; else old=&curr->tree2;
			}			
		}
		for(i=data.array[n].list2; data.list[i]>=0; i++) {
			if(data.list[i]+step>=len2) break;
			if(i<0 || i>=size) printf("(%d,%d)\n",i,size); //_asm { int 3 }
			sym=str2[data.list[i]+step];
			old=&data.array[n].tree;
			for(;;) {
				curr=*old;
				if(!curr) {
					*old=curr=nodes.New();
					curr->sym=sym;
				}
				if(curr->sym==sym) {curr->count2++;break;}
				if(curr->sym<sym) old=&curr->tree1; else old=&curr->tree2;
			}
		}
	}
	//   
	count=size=0;
	for(n=0; n<data.count; n++) TreeCalc(data.array[n].tree);
	if(!count) return true;
	//  
	_data.count=count;
	_data.array=new item_st[count];
	_data.list= new int[size];
	memset(_data.list,-1,size*sizeof(int));
	memset(_data.array,0,count*sizeof(item_st));
	//     (   )
	for(n=0; n<data.count; n++) {
		for(i=data.array[n].list1; data.list[i]>=0; i++) {
			if(data.list[i]+step>=len1) break;
			sym=str1[data.list[i]+step];
			curr=data.array[n].tree;
			for(;;) {
				if(!curr) _asm { int 3 }
				if(curr->sym==sym) break;
				if(curr->sym<sym) curr=curr->tree1; else curr=curr->tree2;
			}			
			l=curr->index; if(l<0) continue;
			_data.array[l].list1=curr->count1;
			m=_data.array[l].list1+_data.array[l].count1++;
			_data.list[m]=data.list[i];
		}
		for(i=data.array[n].list2; data.list[i]>=0; i++) {
			if(data.list[i]+step>=len2) break;
			sym=str2[data.list[i]+step];
			curr=data.array[n].tree;
			for(;;) {
				if(!curr) _asm { int 3 }
				if(curr->sym==sym) break;
				if(curr->sym<sym) curr=curr->tree1; else curr=curr->tree2;
			}			
			l=curr->index; if(l<0) continue;
			_data.array[l].list2=curr->count2;
			m=_data.array[l].list2+_data.array[l].count2++;
			_data.list[m]=data.list[i];
		}

	}	
	printf("count: %d\n",count);
	printf("size: %d\n",size);
	delete []data.list;
	delete []data.array;
	data=_data;
	return false;
}



//  
void Init0()
{
	int n,m; //int count;
	int cc1[256]; memset(cc1,0,sizeof(cc1));
	int cc2[256]; memset(cc2,0,sizeof(cc2));
	int ind[256]; memset(ind,-1,sizeof(ind));
	//    
	for(n=0; str1[n]; n++) cc1[str1[n]]++;
	for(n=0; str2[n]; n++) cc2[str2[n]]++;
	//       
	count=size=0;
	memset(ind,-1,sizeof(ind));
	for(n=0; n<256; n++) {
		if(cc1[n] && cc2[n]) size+=2+cc1[n]+cc2[n],count++; //else cc1[n]=cc2[n]=0;
	}
	//    
	data.list=new int[size];
	data.array=new item_st[count];
	data.count=count;
	for(n=0; n<count; n++) data.array[n].tree=0;
	//    
	int index=0;
	for(n=m=0; n<256; n++) {
		if(!cc1[n] || !cc2[n]) continue;
		data.array[m].count1=data.array[m].count2=0;
		data.array[m].list1=index; index+=cc1[n]+1;
		data.array[m].list2=index; index+=cc2[n]+1;
		ind[n]=m++;
	}
	//   
	int a,b;
	for(n=0; str1[n]; n++) {
		a=ind[str1[n]]; if(a<0) continue;
		b=data.array[a].list1+data.array[a].count1++;
		data.list[b++]=n; data.list[b]=-1;
	}
	for(n=0; str2[n]; n++) {
		a=ind[str2[n]]; if(a<0) continue;
		b=data.array[a].list2+data.array[a].count2++;
		data.list[b++]=n; data.list[b]=-1;
	}
}

void Dump(int step)
{
	int n,m,i; int c=0;
	for(n=0; n<data.count; n++) for(i=data.array[n].list1; data.list[i]>=0; i++) {
		for(m=0; m<step; m++) putchar(str1[data.list[i]+m]); putchar(' ');
	}
	putchar('\n');
}


void main()
{
	int n;
	memset(&data,0,sizeof(data));
	for(n=0; n<SIZE; n++) str1[n]='0'+rand()%8; str1[n]=0;
	for(n=0; n<SIZE; n++) str2[n]='0'+rand()%8; str2[n]=0;
	len1=len2=SIZE;
	printf("l1=%s\n",str1);
	printf("l2=%s\n",str2);
	printf("init0\n");
	Init0();
	step=1;
	for(;;) {
		if(Step()) break;
		step++;
		printf("step: %d\n",step);
		Dump(step);
	}
	delete []data.list;
	delete []data.array;
	printf("[done]\n");
	getchar();
}






